import unittest
from modelverse_kernel.main import ModelverseKernel
from utils import execute_until_finished, MvSWrapper

class Testconstant(unittest.TestCase):
    def setUp(self):
        self.mvs = MvSWrapper()
        self.root = self.mvs.execute("RR", [])[0]
        self.mvk = ModelverseKernel(self.root)

    def test_constant(self):
        root = self.root
        user_root = self.mvs.execute("CN", [])[0]
        user_frame = self.mvs.execute("CN", [])[0]
        phase = self.mvs.execute("CNV", ["init"])[0]
        inst = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        node = self.mvs.execute("CN", [])[0]
        returnvalue = self.mvs.execute("CN", [])[0]

        self.mvs.execute("CD", [root, "user_1", user_root])
        self.mvs.execute("CD", [user_root, "frame", user_frame])
        self.mvs.execute("CD", [user_frame, "phase", phase])
        self.mvs.execute("CD", [user_frame, "IP", inst])
        self.mvs.execute("CD", [user_frame, "returnvalue", returnvalue])
        self.mvs.execute("CD", [inst, "node", node])

        # Do the invocation until it returns None
        execute_until_finished(self.mvk, self.mvs)

        # Execution of the command finished, so the MvS should be in the correct new state right now
        self.assertEquals(self.mvs.execute("RD", [root, "user_1"])[0], user_root)
        self.assertEquals(self.mvs.execute("RD", [user_root, "frame"])[0], user_frame)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [user_frame, "phase"])[0]])[0], "finish")
        self.assertEquals(self.mvs.execute("RD", [inst, "node"])[0], node)
        self.assertEquals(self.mvs.execute("RD", [user_frame, "returnvalue"])[0], node)
